unit GraphApp;

interface
 uses GraphObj;
 type TgraphApp=Object
  HourHand:^THand;
  MinHand:^THand;
  SecHand:^THand;
  Dial:^Tdial;
  constructor init;
  procedure run;
  destructor done;
  procedure ShowAll;
 end;

implementation
 uses Graph,Crt,WinDos;

procedure SendMessage(Msg:string);
begin
 writeln(Msg);
 writeln('  ');
 readkey;
end;

constructor TGraphApp.init;
 var
  d,r,k,MaxX,MaxY:integer;
 begin
  clrscr;
  {樠㥬 ᪨ ०}
  d:=detect;
  InitGraph(d,r, ' ');
  if GraphResult <> grOk then
  begin
   SendMessage(' ᬮ   ᪨ ०');
   Halt(2);
  end;
  SetBkColor(DarkGray);
  MaxX:=GetMaxX;MaxY:=GetMaxY;
  {樠㥬 ணࠬ}
  new(HourHand,init(Round(MaxX/2),Round(MaxY/2),Round(MaxY/5),Green));
  new(MinHand,init(Round(MaxX/2),Round(MaxY/2),Round(MaxY/3),Green));
  new(SecHand,init(Round(MaxX/2),Round(MaxY/2),Round(MaxY/2.5),Red));
  new(Dial,init(Round(MaxX/2),Round(MaxY/2),Round(MaxY/2)-5,White));
  ShowAll;
 end;

destructor TGraphApp.done;
 begin
  dispose(HourHand);
  dispose(MinHand);
  dispose(SecHand);
  dispose(Dial);
  CloseGraph;
 end;

procedure TGraphApp.Run;
var
 stop:boolean;
 Hour, Min, OldSec,Sec, Sec100 : Word;
begin
 stop:=False;
 repeat
  if KeyPressed=true then
   if ReadKey=#27 then Stop:=true;
  { ५}
  GetTime(Hour, Min, Sec, Sec100);
  if Sec<>OldSec then
  begin
   OldSec:=Sec;
   HourHand^.Rotate(Round(Hour*360/12+Min*360/(12*60)-90));
   MinHand^.Rotate(Round(Min*360/60+Sec*360/(60*60)-90));
   SecHand^.Rotate(Round(Sec*360/60-90));
   ShowAll;
  end;
 Until Stop;
end;

procedure TGraphApp.ShowAll;
 begin
  Dial^.Show;
  HourHand^.Show;
  MinHand^.Show;
  SecHand^.Show;
 end;

end.

